using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Simple.OData.Client;

namespace WpfSimpleOdataClient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private static readonly String BASE_ODATA_URL = "http://10.47.86.130:8080/odata/FirePanels2.1";
        private static readonly String USER_NAME = "tycoonadmin";
        private static readonly String USER_PASSWORD = "TycoNET~!2";

        public MainWindow()
        {
            InitializeComponent();

        }

        private async void btnDoSomething_Click(object sender, RoutedEventArgs e)
        {

            try
            {
                var settings = new ODataClientSettings()
                {
                    BaseUri = new Uri(BASE_ODATA_URL),
                    PayloadFormat = ODataPayloadFormat.Unspecified,
                    IgnoreUnmappedProperties = true,
                    IgnoreResourceNotFoundException=true
                };
                settings.BeforeRequest += delegate(System.Net.Http.HttpRequestMessage request)
                {

                    String aux = String.Join(":", new String[] { USER_NAME, USER_PASSWORD });
                    var plainTextBytes = System.Text.Encoding.UTF8.GetBytes(aux);
                    request.Headers.Authorization = new System.Net.Http.Headers.AuthenticationHeaderValue("Basic", System.Convert.ToBase64String(plainTextBytes));
                };

                var client = new ODataClient(settings);

                var panels = await client
                    .For("FirePanels")
                    .FindEntriesAsync();

                foreach (var eachPanel in panels)
                {
                    Console.WriteLine(eachPanel["pkey"]);
                }
            }
            catch (Exception exception)
            {
                String Message = exception.InnerException.Message;
            }
        }


    }
}
